'''
用knn分类算法实现约会数据学习例子
'''
import numpy
from common import file_helper, knn_helper


if __name__ == '__main__':
    ### 1.导入学习数据 ###
    # 组合学习数据存储路径
    file_path = file_helper.get_current_path(__file__) + '\\datingTestSet2.txt'
    # 从文本文件中读取数据内容
    # 40920	8.326976	0.953952	3
    # 14488	7.153469	1.673904	2
    # ......
    lines = file_helper.read_file(file_path)
    # 初始化机器学习数据集
    ml_data = [line.replace('\n', '').split('\t')[0:3] for line in lines]
    # 将最后一列值存储到标签集中
    ml_label = [int(line.replace('\n', '').split('\t')[-1]) for line in lines]
    # 将数组转换为numpy数组
    ml_data = numpy.array(ml_data)
    # 将数组中的值由字符串转为浮点型
    ml_data = ml_data.astype(float)

    # 将学习数据集进行归一化处理（将数值转化为0~1之间的小数）
    normalization_mat = knn_helper.normalization(ml_data)

    # 设置测试的样本数量， numTestVecs:m表示训练样本的数量
    test_count = int(ml_data.shape[0] * 0.1)
    # 初始化出错数量
    error_count = 0

    # 逐项测试knn分类结果
    for i in range(test_count):
        label = ml_label[i]
        # result = knn_helper.knn_classify(normalization_mat[test_count:], ml_label[test_count:], normalization_mat[i], 5)
        result = knn_helper.knn_classify2(normalization_mat[test_count:], ml_label[test_count:], normalization_mat[i], 5)
        error_count += result != label
        if result != label:
            print("knn识别为：%s，真实值为：%s" % (result, label))

    print("\n总错误数量为: {}".format(error_count))
    print("\n总体错误率为: {}%".format(error_count / test_count * 100))
